addnodewindows <-
function() {
	nodeSec <- nodoselecionado()
	if ( nodeSec[1] == " ") {
		msg <- paste("None node selected. Select a tree node and try again.")
		tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
		tkfocus(tt)
	} else {
		node.number <- as.numeric(nodeSec[3])
		node.col <- as.numeric(nodeSec[2])
		position <- intersect(which((TheTree$Level == node.col)),which(TheTree$Node.N == node.number))
		node.type <- TheTree$Type[position]
		if (node.type == "T") {
			msg <- paste(" The selected node type is 'Terminal'.\n Change the node type and try again.")
			tkmessageBox(message = msg, icon="warning", title = "ArvoRe - WARNING")
			tkfocus(tt)
		} else {
			# A janela Tk
			addnodeWindow <- tktoplevel()
			title <- "arvoRe - New Node"
			tkwm.title(addnodeWindow,title)
			
			NomeVar <- tclVar("New Node")
			NomeEntryWidget <- tkentry(addnodeWindow,width="20",textvariable=NomeVar)
			tkgrid(tklabel(addnodeWindow,text="Node name"))
			tkgrid(NomeEntryWidget)
			
			ProbabilidadeVar <- tclVar("0.0")
			ProbabilityEntryWidget <- tkentry(addnodeWindow,width="20",textvariable=ProbabilidadeVar)
			tkgrid(tklabel(addnodeWindow,text="Probability"))
			tkgrid(ProbabilityEntryWidget)
			
			UtilidadeVar <- tclVar("0.0")
			UtilityEntryWidget <- tkentry(addnodeWindow,width="20",textvariable=UtilidadeVar)
			tkgrid(tklabel(addnodeWindow,text="Cost / Payoff"))
			tkgrid(UtilityEntryWidget)
	
			EffectivenessVar <- tclVar("0.0")
			EffectivenessEntryWidget <- tkentry(addnodeWindow,width="20",textvariable=EffectivenessVar)
			tkgrid(tklabel(addnodeWindow,text="Effectiveness / Payoff"))
			tkgrid(EffectivenessEntryWidget)
		
			NotasVar <- tclVar(" ")
			NotesEntryWidget <- tkentry(addnodeWindow,width="20",textvariable=NotasVar)
			tkgrid(tklabel(addnodeWindow,text="Notes"))
			tkgrid(NotesEntryWidget)		
			
			tkfocus(addnodeWindow)
	
			OnOK <- function()
			{
				NameVal <- tclvalue(NomeVar)
				ProbabilidadeVal <- as.character( tclvalue(ProbabilidadeVar) )
				UtilidadeVal <- as.character( tclvalue(UtilidadeVar) )
				EffectivenessVal <- as.character( tclvalue(EffectivenessVar) )
				NotasVal <- tclvalue(NotasVar)
				
				if ( nchar(ProbabilidadeVal) < 1 ) {
					msg <- paste("Invalid probability value/expression '",ProbVal, "'")
					tkmessageBox(message=msg)
					tkfocus(addnodeWindow)
				} else {
					NewTree <- add.node(TheTree,
									node.col = node.col,
									node.number = node.number, 
									node.name = NameVal, 
									node.prob = ProbabilidadeVal, 
									node.type = "C", 
									node.notes = NotasVal,
									node.destiny = " ",
									node.utility = UtilidadeVal,
									node.effectiveness = EffectivenessVal)
					safedofunction(TheTree, .EnvironmentArvoRe, .modeltypeArvore)
					
					commandstringformat <- paste("NewTree <- add.node(TheTree, node.col = ",node.col,", node.number = ",node.number,", node.name = '",NameVal,"', node.prob = '",ProbabilidadeVal,"', node.type = 'C', node.notes = '",NotasVal,"', node.destiny = ' ', node.utility = '",UtilidadeVal,"', node.effectiveness = '",EffectivenessVal,"')",sep="")
					add.Syntax(commandstringformat)
					commandstringformat <- paste("setaddnode(NewTree, .EnvironmentArvoRe)")
					add.Syntax(commandstringformat)
					setaddnode(NewTree, .EnvironmentArvoRe)
					
					refreshF5()
					tkdestroy(addnodeWindow)
					tkfocus(tt)
				}
					
			}
			OK.but <-tkbutton(addnodeWindow,text="   OK   ",command=OnOK)
			tkbind(NomeEntryWidget, "<Return>",OnOK)
			tkbind(ProbabilidadeVar, "<Return>",OnOK)
			tkbind(UtilityEntryWidget, "<Return>",OnOK)
			tkbind(EffectivenessEntryWidget, "<Return>",OnOK)
			tkbind(NotasVar, "<Return>",OnOK)
	
			OnCancel <- function()
			{
				tkdestroy(addnodeWindow)
				tkfocus(tt)
			}
			
			Cancel.but <-tkbutton(addnodeWindow,text=" Cancel ",command=OnCancel)
			tkbind(addnodeWindow, "<Escape>",OnCancel)
	
			tkgrid(OK.but, Cancel.but, sticky = "s", padx = 5, pady = 5)
	
			posiciona.janela.no.mouse(addnodeWindow, 250, 230)
	 		}
 		}
}
