parse.distribution.expression <-
function(exprdistr.arvore) {
	if ( exists("distributionMAT", envir = .EnvironmentArvoRe) ) {
		if ( length(distributionMAT[,1]) >= 1 ) {
			distributionMAT <- get("distributionMAT", envir = .EnvironmentArvoRe)
			
			nexprdistr.arvore <- length(exprdistr.arvore)
			ndistributionMAT <- dim(distributionMAT)[1]
			distributionMAT.Names <- as.character(distributionMAT[,1])
			distributionMAT.Distribution <- as.character(distributionMAT[,3])
			distributionMAT.Parameters <- as.character(distributionMAT[,4])
			
			distributionMAT.ans <- array(exprdistr.arvore,nexprdistr.arvore)
			
			for ( i in 1:ndistributionMAT ) {
				for ( j in 1:nexprdistr.arvore ) {
					if ( sum(str_detect(exprdistr.arvore[j], distributionMAT.Names[i])) > 0 ) { 
						distributionMAT.valornovo <- paste("r", distributionMAT.Distribution[i], "(1, ", distributionMAT.Parameters[i], ")", sep = "")
						commandoprocessar <- str_replace_all(exprdistr.arvore[j], distributionMAT.Names[i], distributionMAT.valornovo)
						# distributionMAT.ans[j] <- eval(parse(text=commandoprocessar)) # no vamos retornar o valor...
						distributionMAT.ans[j] <- commandoprocessar
					}
				}
			}
			return(distributionMAT.ans)
		} else {
			return(exprdistr.arvore)
		}
		
	} else {
		return(exprdistr.arvore)
	}
}
