save.file.arv <-
function(...) {
	if (!exists("variableMAT",.EnvironmentArvoRe)) {
		new.variable.list() # se no existe uma tabela de variaveis, ento ele cria.
		assign("variableMAT", ans, envir = .EnvironmentArvoRe)
	}
	if (!exists("distributionMAT",.EnvironmentArvoRe)) {
		new.distribution.list() # se no existe uma tabela de variaveis, ento ele cria.
		#assign("distributionMAT", ans, envir = .EnvironmentArvoRe)
	}
	
	if ( .opennedfile == "newfile") {
		fileName <- tclvalue(tkgetSaveFile(filetypes="{{ArvoRe Files} {.arv}} {{All files} *}"))
		if (!nchar(fileName))
			tkfocus(tt)
		else {
			ans <- substr(fileName,nchar(fileName)-3,nchar(fileName))
			if ( ans != ".arv" ) fileName <- paste(fileName, ".arv", sep="")			
			save(TheTree, .EnvironmentArvoRe, .modeltypeArvore, markov.propertiesMAT, syntax.file.array, variableMAT, distributionMAT, file = fileName, ascii = TRUE)
			assign(".workstatus", "saved", .EnvironmentArvoRe)
			assign(".opennedfile", fileName, .EnvironmentArvoRe)
			.Windowtitle <- paste("ArvoRe - Main Window", " - [", .opennedfile, "]", sep = "")
			tkwm.title(tt, .Windowtitle)
			tkfocus(tt)
		}
	} else {
			fileName <- .opennedfile
			save(TheTree, .EnvironmentArvoRe, .modeltypeArvore, markov.propertiesMAT, syntax.file.array, variableMAT, distributionMAT, file = fileName, ascii = TRUE)
			assign(".workstatus", "saved", .EnvironmentArvoRe)
			assign(".opennedfile", fileName, .EnvironmentArvoRe)
			.Windowtitle <- paste("ArvoRe - Main Window", " - [", .opennedfile, "]", sep = "")
			tkwm.title(tt, .Windowtitle)
			tkfocus(tt)		
	}
}
